routes/web.php
<?php

use App\Http\Controllers\AlumnoController;
use App\Http\Controllers\CursoController;
use App\Http\Controllers\PerteneceController;
use App\Http\Controllers\PracticaController;
use App\Http\Controllers\PresentaController;
use Illuminate\Support\Facades\Route;

Route::get('/', function () {
    return view('index');
})->name('inicio');

//enrutamiento controlador alumno
Route::resource('alumno', AlumnoController::class);

//enrutammiento controlador curso
Route::resource('curso', CursoController::class);

//enrutamiento controlador practica
Route::resource('practica', PracticaController::class);

//enrutamiento controlador presentacion
Route::resource('presenta', PresentaController::class);


//enrutamiento controlador pertenece
Route::resource('pertenece', PerteneceController::class);

//enrutamiento adicional para practicas
Route::controller(PracticaController::class)->group(function () {
    Route::get('practica/confirmar/{practica}', 'confirmar')
        ->name('practica.confirmar');
});

app/Models/Presenta.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Support\Facades\Schema;

class Presenta extends Model
{
    use HasFactory;

    protected $table = 'presentas';

    //campos de asignacion masiva
    protected $fillable = [
        'alumno_id',
        'practica_id',
        'nota',
    ];

    //creamos atributo estatico con los labels
    public static $labels = [
        'id' => 'ID',
        'alumno_id' => 'ID del Alumno',
        'practica_id' => 'ID de la Practica',
        'nota' => 'Nota',
    ];

    //metodo para devolver el label de un campo
    public function getAttributeLabel($key)
    {
        return self::$labels[$key] ?? $key;
    }

    //metodo para devolver todos los campos
    public function getFields()
    {
        return Schema::getColumnListing($this->table);
    }

    //voy a crear las relaciones entre tablas
    //como la relacion es de muchos se pone en plural
    public function alumno(): BelongsTo
    {
        return $this->belongsTo(Alumno::class, 'alumno_id');
    }

    public function practica(): BelongsTo
    {
        return $this->belongsTo(Practica::class, 'practica_id');
    }
}

app/Http/Controllers/PresentaController.php
<?php

namespace App\Http\Controllers;

use App\Models\Alumno;
use App\Models\Practica;
use App\Models\Presenta;
use Illuminate\Http\Request;

class PresentaController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        //listamos los registros
        $presentas=Presenta::all();
        return view('presenta.index',compact('presentas'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //creamos los alumnos y las practicas
        $alumnos=Alumno::all();
        $practicas=Practica::all();
        //devolvemos la vista
        return view('presenta.create', compact('alumnos', 'practicas'));
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        //creamos la Presenta
        $presenta=Presenta::create($request->all());
        //redirigimos
        return redirect()
        ->route('presenta.show', $presenta);
    }

    /**
     * Display the specified resource.
     */
    public function show(Presenta $presentum)
    {
        return view('presenta.show', compact('presentum'));
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Presenta $presentum)
    {
        return view('presenta.edit')
        //enviamos el listado de alumnos
        ->with('alumnos', Alumno::all())
        //enviamos el listado de practicas
        ->with('practicas', Practica::all())
        //enviamos la Presenta
        ->with('presenta', $presentum);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Presenta $presentum)
    {
        //actualizamos la Presenta
        $presentum->update($request->all());
        //redirigimos
        return redirect()
        ->route('presenta.show', $presentum->id);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Presenta $presentum)
    {
        //eliminamos la Presenta
        $presentum->delete();
        //redirigimos
        return redirect()
        ->route('presenta.index');
    }
}

resources/views/presenta/create.blade.php
@extends('layouts.main')

@section('content')
<div>
    <h1>Presenta nueva practica</h1>
</div>
    <form action="{{ route('presenta.store') }}" method="post" enctype="multipart/form-data">
        @csrf
        <div>
            <label for="nota">Nota</label>
            <input type="number" name="nota" id="nota" value="{{ old('nota') }}">
        </div>
        <div>
            <label>Alumno: </label>
            <select name="alumno_id">
                @foreach ($alumnos as $alumno)
                    <option value="{{ $alumno->id }}"> {{ $alumno->id }} - {{ $alumno->nombre }} {{ $alumno->apellidos }}</option>
                @endforeach
            </select>
        </div>
        <div>
            <label>Practica: </label>
            <select name="practica_id">
                @foreach ($practicas as $practica)
                    <option value="{{ $practica->id }}">{{ $practica->id }} - {{ $practica->titulo }}</option>
                @endforeach
            </select>
        </div>
        <div>
            <button type="submit" class="boton">Guardar</button>
        </div>
    </form>
@endsection

resources/views/presenta/edit.blade.php
@extends('layouts.main')

@section('content')
<div>
    <h1>Actualizar entrega</h1>
</div>
    <form action="{{ route('presenta.update',$presenta) }}" method="post" enctype="multipart/form-data">
        @csrf
        @method('PUT')
        <div>
            <label for="nota">Nota</label>
            <input type="number" name="nota" id="nota" value="{{ old('nota', $presenta->nota) }}">
        </div>
        <div>
            <label>Alumno: </label>
            <select name="alumno_id">
                @foreach ($alumnos as $alumno)
                    <option value="{{ $alumno->id }}" 
                        {{ old('alumno_id', $presenta->alumno_id) == $alumno->id ? 'selected' : '' }}>
                        {{ $alumno->id }} - {{ $alumno->nombre }} {{ $alumno->apellidos }}</option>
                @endforeach
            </select>
        </div>
        <div>
            <label>Practica: </label>
            <select name="practica_id">
                @foreach ($practicas as $practica)
                    <option value="{{ $practica->id }}" 
                        {{ old('practica_id', $presenta->practica_id) == $practica->id ? 'selected' : '' }}>
                        {{ $practica->id }} - {{ $practica->titulo }}</option>
                @endforeach
            </select>
        </div>
        <div>
            <button type="submit" class="boton">Actualizar</button>
        </div>
    </form>
@endsection

resources/views/presenta/index.blade.php
@extends('layouts.main')

@section('content')
    <h1>Entregas</h1>
<div class="listado">
    @foreach ($presentas as $presentum)
        <div class="tarjeta">
            <ul>
                <li>{{ $presentum->id }}</li>
                <li>Nota: {{ $presentum->nota }}</li>
                <li>Alumno: {{ $presentum->alumno->nombre }} {{ $presentum->alumno->apellidos }}</li>
                <li>Practica: {{ $presentum->practica->id }}-{{ $presentum->practica->titulo }}</li>
            </ul>
            <div class="botones">
                <a href="{{ route('presenta.show', $presentum) }}" class="boton">Ver</a>
                <a href="{{ route('presenta.edit', $presentum) }}" class="boton">Editar</a>
                <form action="{{ route('presenta.destroy', $presentum) }}" method="post" id="eliminar">
                    @csrf
                    @method('delete')
                    <button type="submit" class="boton">Borrar</button>
                </form>
            </div>
        </div>
    @endforeach
</div>
@endsection

resources/views/presenta/show.blade.php
@extends('layouts.main')

@section('content')
    <div class="tarjeta">
        <ul>
            <li>{{ $presentum->id }}</li>
            <li>Nota: {{ $presentum->nota }}</li>
            <li>Alumno: {{ $presentum->alumno_id }} {{ $presentum->alumno->nombre }} {{ $presentum->alumno->apellidos }}</li>
            <li>Practica: {{ $presentum->practica_id }} {{ $presentum->practica->titulo }}</li>
        </ul>
        <div class="botones">
            <a href="{{ route('presenta.edit', $presentum) }}" class="boton">Editar</a>
            <form action="{{ route('presenta.destroy', $presentum) }}" method="post" id="eliminar">
                @csrf
                @method('DELETE')
                <button type="submit" class="boton">Borrar</button>
            </form>
        </div>
    </div>
@endsection